%{!?_httpd_mmn: %{expand: %%global _httpd_mmn %%(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)}}

Name: mod_pubcookie
Version: 3.3.4a
Release: 7%{?dist}
Summary: A solution for single sign-on authentication to websites
License: ASL 2.0
Group: System Environment/Daemons
Url: http://pubcookie.org
Source0: http://pubcookie.org/downloads/pubcookie-%{version}.tar.gz
Source1: key.config
Source2: modpubcookie.conf
Source3: pubcookie_login.conf
Source4: keyserver.socket
Source5: keyserver.service
Source6: keyclient.8
Source7: keyserver.8
Patch0: pubcookie-3.3.4a-installdir.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: httpd-devel openssl-devel openldap-devel krb5-devel systemd-units
Requires: mod_ssl
Requires: httpd-mmn = %{_httpd_mmn}

%description
A standalone login server and modules for common web server platforms like
Apache and Microsoft IIS. Together, these components can turn existing
authentication services (like Kerberos, LDAP, or NIS) into a solution for
single sign-on authentication to websites throughout an institution.

%package server
Summary: The pubcookie login server components
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units

%description server
This package contains the login server portion of pubcookie.

%prep
%setup -q -n pubcookie-%{version}
%patch0 -p1
# fix weird .c file permission to shut up rpmlint:
%{__chmod} 0644 src/verify_fork.c

%build
%configure \
    --enable-login \
    --enable-default-des \
    --enable-krb5 \
    --enable-ldap \
    --enable-shadow
%{__make} %{?_smp_mflags} \
    LIBS="-lcom_err" \
    top_builddir=%{_libdir}/httpd \
    top_srcdir=%{_libdir}/httpd

%install
%{__rm} -rf %{buildroot}
%{__make} install DESTDIR=%{buildroot} \
    top_builddir=%{_libdir}/httpd \
    top_srcdir=%{_libdir}/httpd
%{__install} -D -m 0644 %{SOURCE1} %{buildroot}/%{_sysconfdir}/pubcookie/config
%{__install} -D -m 0644 %{SOURCE2} %{buildroot}/%{_sysconfdir}/httpd/conf.d/modpubcookie.conf
%{__install} -D -m 0644 %{SOURCE3} %{buildroot}/%{_sysconfdir}/httpd/conf.d/pubcookie_login.conf
%{__install} -D -m 0644 %{SOURCE4} %{buildroot}/%{_unitdir}/keyserver.socket
%{__install} -D -m 0644 %{SOURCE5} %{buildroot}/%{_unitdir}/keyserver.service
%{__install} -D -m 0644 %{SOURCE6} %{buildroot}/%{_mandir}/man8/keyclient.8
%{__install} -D -m 0644 %{SOURCE7} %{buildroot}/%{_mandir}/man8/keyserver.8

%clean
%{__rm} -rf %{buildroot}

%post server
if [ $1 -eq 1 ] ; then 
  # Initial installation 
  /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%preun server
if [ $1 -eq 0 ] ; then
  # Package removal, not upgrade
  /bin/systemctl --no-reload disable keyserver.socket > /dev/null 2>&1 || :
  /bin/systemctl --no-reload disable keyserver.service > /dev/null 2>&1 || :
  /bin/systemctl stop keyserver.socket > /dev/null 2>&1 || :
  /bin/systemctl stop keyserver.service > /dev/null 2>&1 || :
fi

%postun server
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
  # Package upgrade, not uninstall
  /bin/systemctl try-restart keyserver.socket >/dev/null 2>&1 || :
  /bin/systemctl try-restart keyserver.service >/dev/null 2>&1 || :
fi

%files
%defattr(-,root,root,-)
%doc doc/*.txt doc/config.html doc/install-mod_pubcookie.html doc/mod_pubcookie-directives.html
%config(noreplace) %{_sysconfdir}/pubcookie/config
%config(noreplace) %{_sysconfdir}/httpd/conf.d/modpubcookie.conf
%{_sbindir}/keyclient
%{_mandir}/man8/keyclient.*
%{_libdir}/httpd/modules/mod_pubcookie.so
%dir %{_localstatedir}/lib/pubcookie

%files server
%defattr(-,root,root,-)
%doc doc/install-filter.html doc/install-login.html doc/krb5-getcred.html
%config(noreplace) %{_sysconfdir}/httpd/conf.d/pubcookie_login.conf
%{_unitdir}/keyserver.socket
%{_unitdir}/keyserver.service
%{_sbindir}/keyserver
%{_mandir}/man8/keyserver.*
%{_datadir}/pubcookie
%{_localstatedir}/lib/pubcookie/starter.key

%changelog
* Mon Mar 19 2012 Gabriel Somlo <somlo at cmu.edu> 3.3.4a-7
- httpd-mmn requires added (#803073)

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.3.4a-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Sep 12 2011 Gabriel Somlo <somlo at cmu.edu> 3.3.4a-5
- server startup switched from xinetd to systemd (#737692)

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.3.4a-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Oct 05 2010 Gabriel Somlo <somlo at cmu.edu> 3.3.4a-3
- fixed ia_64 install path

* Sun Sep 05 2010 Gabriel Somlo <somlo at cmu.edu> 3.3.4a-2
- fixed build on F13 and later
- renamed to mod_pubcookie
- added key[client,server] man pages

* Sat Aug 21 2010 Gabriel Somlo <somlo at cmu.edu> 3.3.4a-1
- upgrade to 3.3.4a

* Thu Mar 13 2009 Gabriel Somlo <somlo at cmu.edu> 3.3.3-1
- initial build
